| Oyranos Colour Management System API

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
oyConnector_s Struct Reference
DAG and Image processing API

A filter connection description structure. More...

`#include <oyConnector_s.h>`

Inheritance diagram for oyConnector_s:
Collaboration diagram for oyConnector_s:

## Public Member Functions
OYAPI oyConnector_s *OYEXPORT | oyConnector_New (oyObject_s object)
| allocate a new Connector object More...
OYAPI oyConnector_s *OYEXPORT | oyConnector_Copy (oyConnector_s *connector, oyObject_s object)
| copy or reference a Connector object More...
OYAPI int OYEXPORT | oyConnector_Release (oyConnector_s **connector)
| release and possibly deallocate a oyConnector_s object More...
int | oyConnector_SetName (oyConnector_s *obj, const char *string, oyNAME_e type)
| set the names in a connector More...
const char * | oyConnector_GetName (oyConnector_s *obj, oyNAME_e type)
| set the names in a connector More...
int | oyConnector_IsPlug (oyConnector_s *obj)
| Is this connector a plug or a socket. More...
int | oyConnector_SetIsPlug (oyConnector_s *obj, int is_plug)
| Set this connector as a plug or a socket. More...
const char * | oyConnector_GetReg (oyConnector_s *obj)
| Get the registration for the connection type. More...
int | oyConnector_SetReg (oyConnector_s *obj, const char *type_registration)
| Set this connectors type string. More...
int | oyConnector_SetMatch (oyConnector_s *obj, oyCMMFilterSocket_MatchPlug_f func)
| Set this connectors type check function. More...
oyCMMFilterSocket_MatchPlug_f | oyConnector_GetMatch (oyConnector_s *obj)
| Set this connectors type check function. More...
Public Member Functions inherited from oyStruct_s
const char * | oyStruct_GetText (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| get a text dump More...

## Data Fields
oyStruct_Copy_f | copy
oyStruct_Release_f | release
Data Fields inherited from oyStruct_s
oyStruct_Copy_f | copy
oyStruct_Release_f | release

## Detailed Description

A filter connection description structure.

This structure holds informations about the connection capabilities. It holds common structure members of oyFilterPlug_s and oyFilterSocket_s.

To signal a value is not initialised or does not apply, set the according integer value to -1.

Todo:
  generalise the connector properties

Version
  Oyranos: 0.3.0

Since
  2008/07/26 (Oyranos: 0.1.8)

Date
  2011/01/31

## Member Function Documentation

OYAPI oyConnector_s *OYEXPORT oyConnector_Copy | ( | oyConnector_s * | connector,
|  | oyObject_s | object
| ) |  |

copy or reference a Connector object

Function oyConnector_Copy

The function is for copying and for referencing. The reference is the most often used way, which saves resourcs and time.

Parameters

  [in] | connector | Connector struct object
  | object | NULL - means reference, the optional object triggers a real copy

References oyOBJECT_CONNECTOR_S.

Referenced by oyFilterNode_s::oyFilterNode_ShowConnector(), oyFilterPlug_s::oyFilterPlug_GetPattern(), and oyFilterPlug_s::oyFilterSocket_GetPattern().

oyCMMFilterSocket_MatchPlug_f oyConnector_GetMatch | ( | oyConnector_s * | obj | ) |

Set this connectors type check function.

Function oyConnector_GetMatch

This is use as a check, if connections are possible. This allowes for a more fine grained control than the type registration.

Parameters

  [in] | obj | Connector object

Returns
  the check function

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

References oyOBJECT_CONNECTOR_S.

Referenced by oyFilterNode_s::oyFilterNode_ConnectorMatch().

const char * oyConnector_GetName | ( | oyConnector_s * | obj,
|  | oyNAME_e | type
| ) |  |

set the names in a connector

Function oyConnector_GetName

Get UI strings.

Parameters

  [in] | obj | Connector object
  [in] | type | the names type

Returns
  the name string

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

References oyOBJECT_CONNECTOR_S.

const char * oyConnector_GetReg | ( | oyConnector_s * | obj | ) |

Get the registration for the connection type.

Function oyConnector_GetReg

This is use as a rough check, if connections are possible.

Parameters

  [in] | obj | Connector object

Returns
  registration string

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

References oyOBJECT_CONNECTOR_S.

Referenced by oyFilterNode_s::oyFilterNode_ConnectorMatch(), and oyFilterNode_s::oyFilterNode_GetConnectorPos().

int oyConnector_IsPlug | ( | oyConnector_s * | obj | ) |

Is this connector a plug or a socket.

Function oyConnector_IsPlug

Parameters

  [in] | obj | Connector object

Returns
  boolean; 0 - socket; 1 - plug

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

References oyOBJECT_CONNECTOR_S.

OYAPI oyConnector_s *OYEXPORT oyConnector_New | ( | oyObject_s | object | ) |

allocate a new Connector object

Function oyConnector_New

References oyOBJECT_OBJECT_S.

OYAPI int OYEXPORT oyConnector_Release | ( | oyConnector_s ** | connector | ) |

release and possibly deallocate a oyConnector_s object

Function oyConnector_Release

Parameters

  [in,out] | connector | Connector struct object

References oyOBJECT_CONNECTOR_S.

Referenced by oyFilterNode_s::oyFilterNode_ConnectorMatch().

int oyConnector_SetIsPlug | ( | oyConnector_s * | obj,
|  | int | is_plug
| ) |  |

Set this connector as a plug or a socket.

Function oyConnector_SetIsPlug

Parameters

  [in,out] | obj | Connector object
  [in] | is_plug | boolean; 0 - socket; 1 - plug

Returns
  1 - error; 0 - success; -1 - otherwise

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

References oyOBJECT_CONNECTOR_S.

int oyConnector_SetMatch | ( | oyConnector_s * | obj,
|  | oyCMMFilterSocket_MatchPlug_f | func
| ) |  |

Set this connectors type check function.

Function oyConnector_SetMatch

This is use as a check, if connections are possible. This allowes for a more fine grained control than the type registration.

Parameters

  [in,out] | obj | Connector object
  [in] | func | the check function

Returns
  1 - error; 0 - success; -1 - otherwise

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

References oyOBJECT_CONNECTOR_S.

int oyConnector_SetName | ( | oyConnector_s * | obj,
|  | const char * | string,
|  | oyNAME_e | type
| ) |  |

set the names in a connector

Function oyConnector_SetName

These are UI strings, e.g. "Img", "Image", "Image Socket" .

Parameters

  [in,out] | obj | Connector object
  [in] | string | the name to set
  [in] | type | the names type

Returns
  1 - error; 0 - success; -1 - otherwise

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

References oyOBJECT_CONNECTOR_S.

int oyConnector_SetReg | ( | oyConnector_s * | obj,
|  | const char * | type_registration
| ) |  |

Set this connectors type string.

Function oyConnector_SetReg

This is use as a rough check, if connections are possible.

Parameters

  [in,out] | obj | Connector object
  [in] | type_registration | the registration string to describe the type

Returns
  1 - error; 0 - success; -1 - otherwise

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

References oyOBJECT_CONNECTOR_S.

## Field Documentation

oyStruct_Copy_f oyConnector_s::copy

copy function

oyStruct_Release_f oyConnector_s::release

release function